# -*- coding: utf-8 -*-
"""
Created on Wed Jun 24 12:05:19 2020

@author: iver_

This program is only for plotting previous data sets and calculating error metrics.
"""


import numpy as np
import matplotlib.pyplot as plt
import numpy.linalg as la
from control import *
from casadi import *
from fp_lib import *
import scipy.io as io

data = io.loadmat('3006_N10_step.mat')

esn = data['esn']
plant = data['plant']
inputs = data['input']
cost_value = data['cost_value']
# error = data['error']

plt.rcParams.update({'font.size': 14})


length = len(esn)
sim_tim = length/12

x_reference = np.empty(length)


time = np.linspace(0,sim_tim,length)

# x_reference[0:int(length/3)] = 75e5
# x_reference[int(length/3):] = 68e5

# Step
x_reference[0:int(length/12)] = 82e5
x_reference[int(length/12):] = 79e5
x_reference[int(length/12)+48:] = 76e5
x_reference[int(length/12)+96:] = 73e5
x_reference[int(length/12)+144:] = 70e5



# plt.figure(2)
# # plt.plot(y_test[200:,0]/10**5,color='blue', label='$p_{bh}$ real')
# plt.plot(time, error.T,color='red')
# plt.grid()
# plt.legend()
# plt.ylabel('Error $[\%]$')
# plt.xlabel(r'Time [Min]')

# plt.figure(2)
# plt.ylim([-0.1,3.5])
# plt.plot(time, error.T,color='red')
# plt.grid()
# plt.legend()
# plt.ylabel('Error $[\%]$')
# plt.xlabel(r'Time [Min]')

plt.figure(48) #.suptitle('ESN')
plt.subplot(511)
plt.plot(time, plant[1:,0]/10**5,color='blue')
plt.plot(time, x_reference/10**5, color='darkgoldenrod', label='reference')
plt.grid()
plt.legend()
plt.ylabel('$p_{bh} \ [bar]$')

plt.subplot(512)
plt.plot(time, plant[1:,1]/10**5,color='blue')
#plt.plot(time, x_reference[1, :]/10**5, color='darkgoldenrod', label='reference')
plt.grid()
plt.legend()
plt.ylabel('$p_{wh} \ [bar]$')

plt.subplot(513)
plt.plot(time, plant[1:,2]*3600,color='blue')
#plt.plot(time, x_reference[2, :]*3600, color='darkgoldenrod', label='reference')
plt.grid()
plt.legend()
plt.ylabel('$q \ [\dfrac{m^3}{h}]$')
plt.xlabel('Time  [min]')


au1 = plt.subplot(514)
au1.set_ylim([0, 105])
plt.step(time,inputs[:,0]*100,color='red', label='$z$')
plt.grid()
#plt.legend()
plt.ylabel('$z \ [\%]$')

    
au2 = plt.subplot(515)
au2.set_ylim([30, 70])
plt.step(time,inputs[:,1],color='red', label='$f$')
plt.grid()
#plt.legend()
plt.ylabel('$f \ [Hz]$')
plt.xlabel('Time [min]')




e_t = np.empty(len(esn))

for k in range(len(esn)):
    e_t[k] = abs(plant[k,0]-x_reference[k])
    
e_total = np.sum(e_t)/1e5
plt.figure(300)
plt.plot(time, e_t/1e5)

e_total_mean = e_total/len(esn)

delta_z = np.empty(len(esn))

for k in range(len(esn)-1):
    delta_z[k] = abs(inputs[k,0]-inputs[k+1,0])

max_z = np.max(delta_z)*100


delta_f = np.empty(len(esn))

for k in range(len(esn)-1):
    delta_f[k] = abs(inputs[k,1]-inputs[k+1,1])

max_f = np.max(delta_f)


total_delta_f = np.sum(delta_f)
total_delta_z = np.sum(delta_z)*100


# plt.subplot(514)
# plt.step(time,inputs[:,0]*100,color='red', label='$z$')
# plt.grid()
# #plt.legend()
# plt.ylabel('$z \ [\%]$')

    
# plt.subplot(515)
# plt.step(time,inputs[:,1],color='red', label='$f$')
# plt.grid()
# #plt.legend()
# plt.ylabel('$f \ [Hz]$')
# plt.xlabel('Time [min]')
